local ENEMYSIZE = 120
local MONITORSIZE = 112
local RINGSIZE = 105
local TOKENSIZE = 160
local STARSIZE = 110

addHook("MapThingSpawn", function(mo, mt)
	if mapheaderinfo[gamemap].scalestuff == nil return end
	if mo == nil return end
	
	local info = mobjinfo[mo.type]
	
	if (mo.flags & MF_SCENERY)
		local s = 25 * mt.extrainfo
		if mt.extrainfo == 0
			s = 100
		end
		mt.scale = ($ * s) / 100
		mo.scale = mt.scale
		mo.destscale = mo.scale
	end
	if (info.flags & MF_ENEMY)
		mt.scale = ($ * ENEMYSIZE) / 100
		mo.scale = mt.scale
		mo.destscale = mo.scale
	end
	if (info.flags & MF_MONITOR)
		mt.scale = ($ * MONITORSIZE) / 100
		mo.scale = mt.scale
		mo.destscale = mo.scale
	end
	if (mo.type == MT_RING)
		mo.scale = ($ * RINGSIZE) / 100
		mo.destscale = mo.scale
	end
	if (mo.type == MT_TOKEN)
		mo.scale = ($ * TOKENSIZE) / 100
		mo.destscale = mo.scale
	end
	if (mo.type == MT_STARPOST)
		mo.scale = ($ * STARSIZE) / 100
		mo.destscale = mo.scale
	end
end)