--Thanks to Golden on discord for this script

local function playerJumped(player)
	if mapheaderinfo[gamemap].scalestuff == nil return end
	if not player.mo or not player.mo.valid then
		return
	end

	local mo = player.mo

	player.jumped = $ == INT32_MAX and INT32_MAX-1 or $

	if player.jumped then
		return
	end

	player.jumped = $ and $ + 1 or 1 // Increase by 1 (even if nil or 0)

	if mo.standingslope and P_IsObjectOnGround(mo) then
		P_DoJump(player) // does NOT call P_SlopeLaunch!
		mo.momz = $ * 2/3
		return true
	end
end

local function playerThink(player)
	if mapheaderinfo[gamemap].scalestuff == nil return end
	if player.jumped and not (player.cmd.buttons & BT_JUMP) then
		player.jumped = 0
	end

	if player.powers[pw_justlaunched] and not ((player.powers[pw_shield] & SH_BUBBLEWRAP) and (player.pflags & PF_THOKKED)) and (player.mo.state != S_PLAY_PAIN)
		player.mo.momz = min(47 * FRACUNIT, $ * 31/20)
		if (player.mo.momz > 0) and ((player.mo.state == S_PLAY_WALK) or (player.mo.state == S_PLAY_RUN) or (player.mo.state == S_PLAY_STND) or (player.mo.state == S_PLAY_SKID))
			player.mo.state = S_PLAY_SPRING
			player.spring_grav = true
		end
	end
end

addHook("JumpSpecial", playerJumped)
addHook("PlayerThink", playerThink)